#include <iolib-cxx.h>
#include <iolib-filters-cxx.h>

int main()
{
	OutStream	*console = new OutStream(STREAM_ANSI, stdout);
	OutStream	*out = new OutStream(STREAM_FILE, "test.out", OS_OVERWRITE);
	FilterXOR	*filter_xor = new FilterXOR();

	filter_xor->SetModifier(2135456343);

	out->SetFilter(filter_xor);

	console->OutputString("Writing \'This is a test for the new IOLib-Filters library!\' 100 times...");

	for (int i = 0; i < 100; i++)
	{
		out->OutputString("This is a test for the new IOLib-Filters library!\n");
	}

	out->RemoveFilter();

	console->OutputString("done.\n");

	delete out;

	InStream	*in = new InStream(STREAM_FILE, "test.out");

	in->SetFilter(filter_xor);

	console->OutputString("Reading from the file again:\n");

	for (int j = 0; j < 49; j++)
	{
		in->InputString(50);
	}

	console->OutputString(in->InputString(50));

	for (int k = 0; k < 49; k++)
	{
		in->InputString(50);
	}

	console->OutputString(in->InputString(50));

	in->RemoveFilter();

	delete in;
	delete filter_xor;
	delete console;

	return 0;
}
