#include <iolib-objc.h>
#include <iolib-filters-objc.h>

int main()
{
	OutStream	*console = [OutStream new];
	OutStream	*out = [OutStream new];
	FilterXOR	*filter_xor = [FilterXOR new];
	InStream	*in;
	int		 i;

	[console Connect: STREAM_ANSI, stdout];

	[out Connect: STREAM_FILE, "test.out", OS_OVERWRITE];

	[filter_xor SetModifier: 2135456343];

	[out SetFilter: filter_xor];

	[console OutputString: "Writing \'This is a test for the new IOLib-Filters library!\' 100 times..."];

	for (i = 0; i < 100; i++)
	{
		[out OutputString: "This is a test for the new IOLib-Filters library!\n"];
	}

	[console OutputString: "done.\n"];

	[out RemoveFilter];

	[out free];

	in = [InStream new];

	[in Connect: STREAM_FILE, "test.out"];

	[in SetFilter: filter_xor];

	[console OutputString: "Reading from the file again:\n"];

	for (i = 0; i < 49; i++)
	{
		[in InputString: 50];
	}

	[console OutputString: [in InputString: 50]];

	for (i = 0; i < 49; i++)
	{
		[in InputString: 50];
	}

	[console OutputString: [in InputString: 50]];

	[in RemoveFilter];

	[in free];
	[filter_xor free];
	[console free];

	return 0;
}
